/*  
  Scrivere un programma che legga da input un array di interi ordinati in ordine non decrescente. 
  Il primo valore non intero letto da input termina la lettura da input. 
  Controllare che l'array sia effettivamente ordinato in ordine non decrescente, 
  in tale caso scrivere in output "SI x \n", dove x sta per il numero di elementi distinti 
  in esso contenuti, o "NO\n" altrimenti. 
*/

#include <stdlib.h>
#include <stdio.h>

int main() {

 
  int dimensione = 0; // numero interi attualmente letti 
  int capacita = 1;   // dimensione blocco corrente (inizialmente 1) 
  int *tmp;	      // puntatore ausiliario per la riallocazione	
  int *A; 	      // puntatore al blocco corrente 
  int i;
  int elemento;       // nuovo elemento inserito dall'utente	  
  int ordinato = 1;   // binario che sarà 1 se la sequenza inserita è ordinata, 0 altrimenti
  int distinti;	      // variabile che conterrà il numero di elementi distinti nell'input	


  A = (int *) malloc( sizeof(int)* capacita );
  if( A == NULL ) return 1;

  while( scanf("%d", &elemento) == 1) {  // il ciclo termina se viene rilevato EOF (redirezione) o se l'input 						 // non è interpretabile come intero, ad es.: un carattere

    A[dimensione] = elemento;
    dimensione++;                       // si può riscrivere come A[dimensione++] = elemento;

    if( dimensione == capacita )        // se lo spazio di A è esaurito effettua la riallocazione
        { 
	 
          // alloca un nuovo blocco di capacità doppia, e salva in tmp un puntatore al nuovo blocco 
	  capacita *= 2;               
	  tmp = (int *) malloc( sizeof(int) * capacita );
	  if( tmp == NULL ) return 1;	
	  
	  // copia gli elementi nel nuovo blocco allocato 
	  for ( i = 0; i < dimensione; i++ ) 
	      tmp[i] = A[i];

	  free(A);                    // libera lo spazio occupato dal blocco di memoria precedente 
	  A = tmp;                    // A diventa il puntatore al nuovo blocco di memoria
      }
  
      /* l'intero corpo dell'if si può reimplementare con una singola chiamata alla funzione
         realloc dichiarata in <stdlib.h> (vedi documentazione):
  
                capacita*=2; A = realloc(A, capacita * sizeof(int));
      */
  }  


  /* controlla se l'array è ordinato o meno */
  for ( i = 0; i < dimensione-1; i++ ) 
	if( A[i] > A[i+1] ) { 
	      ordinato = 0;
	      break;
        }

  /* se non è ordinato stampa NO\n ed esce */
  if (!ordinato) {                   
      printf("NO\n");
      return 0;
  }
  
  /* in caso contrario, conta il numero di elementi distinti e lo stampa preceduto da SI.
     Si noti che la sequenza è ordinata, dunque basta una singola scansione di A come segue: */ 
  
  distinti = 1;
  for ( i = 0; i < dimensione-1; i++ ) 
      if( A[i] != A[i+1] )            // ogni volta che trova la prima occorrenza di un nuovo valore 
         distinti++;		      // incrementa il contatore  
          

  printf("SI %d\n", distinti);

  return 0;
}
